<?php
// version:15.0.0.4
// Steven Davis 250405
global $subroot;
include($subroot . "customconfig.php");
$ip404 = $_SERVER['HTTP_CLIENT_IP']
	?? $_SERVER["HTTP_CF_CONNECTING_IP"] // Using Cloudflare
	?? $_SERVER['HTTP_X_FORWARDED']
	?? $_SERVER['HTTP_X_FORWARDED_FOR']
	?? $_SERVER['HTTP_FORWARDED']
	?? $_SERVER['HTTP_FORWARDED_FOR']
	?? $_SERVER['REMOTE_ADDR']
	?? '0.0.0.0';

$url = $_SERVER ['REQUEST_URI'];
if($errortime) $errdate = date ("D d M Y h:i:s a", time());
else $errdate = date("D-d-M-Y H:i:s",time());
$logstatus = $url . " - 404 ERROR";

$logstring = $logstatus;
writelog($logstring);

if($errlog) {
	$newline = $errdate.' --- '.$ip404.' ---- '.$url."\n";
	$errfile = "404_error_log.dat";
	if( !file_exists($errfile) ) {
		$fp = fopen($errfile,"c+");
		flock($fp, LOCK_EX);
		fwrite($fp, $newline);
		flock($fp, LOCK_UN);
		fclose($fp);
	}
	else {
		$fp = fopen($errfile, "r+");
		if($fp) {
			$locked = getLock($fp, LOCK_SH);
			if($locked) {
				flock($fp, LOCK_UN);
				$lines = file( $errfile );
				$locked = getLock($fp, LOCK_EX);

				if($locked && $lines !== false) {
					if( $maxerrlines ) {
						$linecount = sizeof($lines);
						while($linecount >= $maxerrlines) {
							array_pop( $lines );
							$linecount--;
						}
						array_unshift( $lines, $newline );
						$towrite = join('',$lines);

						ftruncate($fp,0);
						fwrite($fp,$towrite);
						fflush($fp);
					}
				}
				flock($fp, LOCK_UN);
			}
			fclose($fp);
		}
	}
}
if($ban_404_ip && file_exists("private") ) {
	header("Location: private/index.php");
	exit;
}
?>
